<?php
/*
 * Benno MailArchiv
 *
 * Copyright  2008-2012 LWsystems GmbH & Co. KG
 *
 * http://www.lw-systems.de/
 * http://www.benno-mailarchiv.de/
 *
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License version 3
 * as published by the Free Software Foundation.
 *
 * Binary versions of this file provided by LWsystems to you as
 * well as other copyrighted, protected or trademarked materials like
 * logos, graphics, fonts, specific documentations and configurations,
 * cryptographic keys etc. are subject to a license agreement between
 * you and LWsystems.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You can find a copy of the GNU Affero General Public License at
 * this URI:
 * http://www.gnu.org/licenses/agpl-3.0.html
 * If not, write to the Free Software Foundation, Inc., 59 Temple Place,
 * Suite 330, Boston, MA  02111-1307  USA
 */

// EMail from session (s.a. pre_ctrl)
$filename    = $App->getParam('name');
$attachmentId = $App->getParam('attachmentId');
$contentType = $App->getParam('type');
$sessionMailId = $App->getParam('id');

$disposition = 'attachment';
$show_inline = $App->getConfigList('ATTACHMENT_INLINE',array('application/pdf','image/png'));

if (in_array($contentType,$show_inline)) {  // --> a_showEmail
    $disposition = 'inline';
}
else { // show inline if file suffix matches
    $itype_list = $App->getConfiglist('ATTACHMENT_INLINE_SUFFIX',array('application/pdf','image/png'));
    foreach ($itype_list as $itype) {
    list($type,$isuffix) = explode('/',$itype);
        if (preg_match("/\.$isuffix$/i", $filename)) {
            $disposition = 'inline';
            $contentType = $itype;
        }
    }
}

try {
    $filename = urlencode($filename);
    $attachmentData = $Backend->fetchAttachment($archive,$sessionMailId,$filename, $attachmentId);
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Pragma: public");
    header('Content-Type: '.$contentType);
    header("Content-Disposition: $disposition; filename=\"$filename\";");

    print $attachmentData;
    exit;
}
catch (Exception $e) {
    $App->log('[downloadAttachment] '.$e->getMessage());
    $App->setMsg($e->getMessage());
    $App->view = 'error';
}

?>
